/* * *
	untinfo.js v1.1 30.03.2007
	(cc) 2006 Filipp Lepalaan <filipp@mac.com>
*/

var teamPageBaseUrl = "http://fah-web.stanford.edu/cgi-bin/main.py?qtype=teampage&teamnum=";
var cacheFileBase	= "/private/var/tmp/widget-unitinfo-";
var unitInfoFile, clientConfigFile, clientVersion, foldingBase;

var checkInterval	= 1;	// Refresh interval in days

// That's all you should have to change //
var awk, curl;

var userName, localUserName, teamNumber;
var gInfoButton, gDoneButton, front, back;
var teamPageUrl, cacheFile, unitInfoFile;

var animator; 
var debug = false;

//	Only call this once!
function loaded ()
{	
	gDoneButton = new AppleGlassButton (document.getElementById ('doneButton'), 'Done', togglePrefs);
	gInfoButton = new AppleInfoButton (document.getElementById ('infoButton'), document.getElementById ('front'), 'white', 'white', togglePrefs);
	
	animator = new AppleAnimator (3000, 200, 0, 10, animationHandler);
	document.getElementById ('statusDiv').style.display = 'block';
	widget.onshow = updateStatus;
	
	awk = "/usr/bin/awk -v ORS=\"\"";
	curl = "/usr/bin/curl";
	
	foldingBase = "~/Library/InCrease/cpu*/";	
	var fp = widget.system ('/usr/bin/file -bi ' + foldingBase + 'unitinfo.txt', null).outputString.replace ("\n", "");
	
	if (fp.indexOf ("text/plain") != -1)
	{
		clientConfigFile = "~/Library/InCrease/cpu1/client.cfg"; // Just default to the CPU 1 config
		clientVersion = 'InCrease';
	} else {
		foldingBase = "~/Library/Folding@Home/";
		clientConfigFile = foldingBase + "client.cfg"
		clientVersion = 'Folding@Home';
	}
	
	unitInfoFile = foldingBase + 'unitinfo.txt'; // Status will be averaged between all CPUs for InCrease
	
	if (debug)
	{
		alert (unitInfoFile);
		alert (clientConfigFile);
	}
	
	front	= document.getElementById ('front');
	back 	= document.getElementById ('back');
	
	animator.start ();
	init ();
}

/* * *
	Init UI & get paths to CLI executables. Update preferences.
	Strip newlines! // ORS="" cuts off the trailing newlines from matches.
	Only call this once!
*/
function init ()
{	
	widget.setPreferenceForKey (new Date ().getTime (), 'lastChecked');			// Just in case (for timeouts etc)
	
	storedUserName 		= widget.preferenceForKey ('userName');
	storedTeamNumber 	= widget.preferenceForKey ('teamNumber');
	localUserName		= getUserInfo ('username');

	// Prefs take precedence
	userName 	= (storedUserName != null) ? storedUserName : localUserName;
	teamNumber 	= (storedTeamNumber != null) ? storedTeamNumber : getUserInfo ('team');
	
	if (userName == null || teamNumber == null)
		return togglePrefs (); // FAH not installed
	
	teamPageUrl = teamPageBaseUrl + teamNumber;
	cacheFile 	= cacheFileBase + userName + '.html';
	
	// Collect all important info into one file and show it once it's done
	widget.system (curl + ' -s -o ' + cacheFile + ' "' + teamPageUrl + '"', showInfo);
}

//	Display the info from preferences //
function showInfo ()
{
	if (animator.running)
		animator.stop ();
	updateUserInfo (userName, teamNumber);

	document.getElementById ('statusDiv').style.display = 'none';
	document.getElementById ('userNameDiv').innerHTML = '<a onclick="widget.openURL(\'' + widget.preferenceForKey ('teamPageUrl') + '\');">' + widget.preferenceForKey ('userName') + '@' + widget.preferenceForKey ('teamName') + '</a>';
	
	document.getElementById ('rankDiv').innerText = widget.preferenceForKey ('userRank');
	document.getElementById ('wuCountDiv').innerText = widget.preferenceForKey ('userWUCount') + ' units completed';
	
	updateStatus ();
}

// Grab the latest info and store in prefs.
function updateUserInfo (newUserName, newTeamNumber)
{
	widget.setPreferenceForKey (getUserWUCount (newUserName), 'userWUCount');
	widget.setPreferenceForKey (getUserRank (newUserName), 'userRank');
	widget.setPreferenceForKey (getCurrentStatus (), 'currentStatus');
	widget.setPreferenceForKey (getTeamName (), 'teamName');
	widget.setPreferenceForKey (teamPageUrl, 'teamPageUrl');
}

/* * *
	Show or hide the preferences backside
	Should basically refresh everything after the user clicks OK, but not use init() since that
	creates extra buttons.
*/
function togglePrefs ()
{	
	if (back.style.display == 'none' && window.widget)
	{
	  widget.prepareForTransition ('ToBack');
		front.style.display	= 'none';
		back.style.display	= 'block';
		
		document.getElementById ('userNameInput').value		= widget.preferenceForKey ('userName');
		document.getElementById ('teamNumberInput').value	= widget.preferenceForKey ('teamNumber');
	} else {
		widget.setPreferenceForKey (document.getElementById ('userNameInput').value, 'userName');
		
		var teamNumber = document.getElementById ('teamNumberInput').value;
		var teamNumber = (teamNumber == "") ? 0 : parseInt (teamNumber);	// If no team given, assume 0
		
		if (!isNaN (teamNumber))
		{
			widget.setPreferenceForKey (teamNumber, 'teamNumber');
			init ();
			widget.prepareForTransition ('ToFront');
    	back.style.display 	= 'none';
    	front.style.display	= 'block';
		} else {
			document.getElementById ('teamNumberInput').focus ();	// Invalid team number
		}
	}
	
	setTimeout ('widget.performTransition();', 0);
	
}

/* * *
	There's two ways of getting user info:
	From prefs or from client.cfg
	Prefs take precedence
*/
function getUserInfo (key) 
{
	return widget.system (awk + " -F '=' '/" + key + "=/ {print $2}' " + clientConfigFile, null).outputString;
}

// RS="" and FS="\n" kind of "flip" the table
function getUserRank (userName)
{
	if (debug)
		alert (cacheFile);
	out = widget.system (awk + " 'BEGIN {RS=\"\"; FS=\"\\n\";} /<TD>.([0-9])+.<\\/TD>.*" + userName + "/ {print $2}' " + cacheFile, null).outputString.match (/>(.+)</)[1];
	return (out == null) ? "-" : out;
}

// Use alert (cmd) to debug //
function getUserWUCount (userName)
{
	var out = widget.system (awk + " '/cert.php\\?u=" + userName + "&pts=[0-9]+&t/ {print $4}' " + cacheFile, null).outputString;
	return (out == null) ? 'Unknown amount of ' : out;
}

// This should always succeed //
function getTeamName ()
{
	if (debug)
		alert (cacheFile);
	
	try {
		_out = widget.system ('egrep "<TD><font size=5><b>" ' + cacheFile, null).outputString.match (/<b>\s(.*)\s<\/b>/)[1];
		return _out;
	} catch (e) {
		return '-';
		}
}

function getCurrentStatus ()
{
	if (debug)
		alert (localUserName);
		
	if (userName != localUserName)
		return '-'; // Can't get current status of remote users.
	
	var percent = widget.system (awk + " '/Progress: / {print $2}' " + unitInfoFile, null).outputString.split ("%");
	percent.pop ();	// Remove last empty value
	
	var tot = 0;
	for (var i = 0; i < percent.length; i++)
		tot += parseInt (percent[i]);
		
	if (debug)
		alert (tot);
	
	return tot / percent.length;
}

function getCurrentProtein ()
{
	return widget.system (awk + " '/Name: / {print $2}' " + unitInfoFile, null).outputString;
}

function updateStatus ()
{
	with (document.getElementById ('currentStatusDiv'))
	{
		title = 'Working on: ' + getCurrentProtein () + " (running " + clientVersion + ")";
		innerText	= 'Currently @ ' + getCurrentStatus () + "%";
	}
	
	if ((widget.preferenceForKey ('lastCheck') - new Date ().getTime ()) > (3600 * 24 * checkInterval)) init ();
}

/* * *
	Update progress indicator. Disabled for now.
	Should get a nice spinner
*/
function animationHandler (animation, current, start, finish)
{
	//document.getElementById ('wuCountDiv').innerHTML += '|';
}
